PROGRAM_NAME='Main'
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/05/2006  AT: 09:00:25        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

dvMaster		=	0:1:0;
dvServer		=	0:4:0;

dvTP			=	10001:1:0;

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

nTestPort = 4000

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

IP_ADDRESS_STRUCT Master_IP

CHAR sIncoming[500]

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)
(* EXAMPLE: DEFINE_FUNCTION <RETURN_TYPE> <NAME> (<PARAMETERS>) *)
(* EXAMPLE: DEFINE_CALL '<NAME>' (<PARAMETERS>) *)

DEFINE_FUNCTION fnParseIncoming()
{
	STACK_VAR CHAR sOneCommand[20]
	WHILE(LENGTH_ARRAY(sIncoming))
	{
		IF(FIND_STRING(sIncoming,"$0D",1))
		{
			sOneCommand = REMOVE_STRING(sIncoming,"$0D",1)
			SET_LENGTH_STRING(sOneCommand,LENGTH_STRING(sOneCommand)-1) //remove the $0D
			send_string 0,"'sOneCommand = ',sOneCommand"
			
			SWITCH(sOneCommand)
			{
				CASE 'kill app zoom':
				{
					SEND_COMMAND dvTP,"'^APP-us.zoom.zrc'"
				}
			}
		}
	}
}
(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

GET_IP_ADDRESS(0:0:0,Master_IP)

IP_SERVER_OPEN(dvServer.Port,nTestPort,IP_TCP) //Initialze server on startup

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

DATA_EVENT[dvServer]
{
	ONERROR:
	{
		SEND_STRING 0,"'error: server=',ITOA(Data.Number)"
	}
	ONLINE:
	{
		SEND_STRING 0,"'online: server'"
	}
	OFFLINE:
	{
		SEND_STRING 0,"'offline: server'"
		IP_SERVER_OPEN(dvServer.Port,nTestPort,IP_TCP)
	}
	STRING:
	{
		SEND_STRING 0,"'string: client=',Data.Text"
		sIncoming = "sIncoming,DATA.TEXT" //here are the incoming strings from the Zoom Room JSON
		fnParseIncoming()
	}
}

BUTTON_EVENT[dvTP,1] //If you want to open or close the server for testing
{
	PUSH:
	{
		IP_SERVER_OPEN(dvServer.Port,nTestPort,IP_TCP)
	}
}
BUTTON_EVENT[dvTP,2]
{
	PUSH:
	{
		IP_SERVER_CLOSE(dvServer.Port)
	}
}


(*****************************************************************)
(*                                                               *)
(*                      !!!! WARNING !!!!                        *)
(*                                                               *)
(* Due to differences in the underlying architecture of the      *)
(* X-Series masters, changing variables in the DEFINE_PROGRAM    *)
(* section of code can negatively impact program performance.    *)
(*                                                               *)
(* See Differences in DEFINE_PROGRAM Program Execution section *)
(* of the NX-Series Controllers WebConsole & Programming Guide   *)
(* for additional and alternate coding methodologies.            *)
(*****************************************************************)

DEFINE_PROGRAM

(*****************************************************************)
(*                       END OF PROGRAM                          *)
(*                                                               *)
(*         !!!  DO NOT PUT ANY CODE BELOW THIS COMMENT  !!!      *)
(*                                                               *)
(*****************************************************************)


